package edu.umass.cs.geni.ec2.accounting;

import java.rmi.Remote;
import java.rmi.RemoteException;

public interface S3ProxyInterface extends Remote
{

  /**
   * Put the given data in bucketName/objectName (bucketName is passed to the
   * constructor)
   * 
   * @param objectName
   *          Name of the object to put in the bucket (use this name to retrieve
   *          the object)
   * @param data
   *          Data to insert in the bucket
   * @throws Exception
   *           if the command fails
   */
  public abstract void put(String objectName, byte[] data)
	  throws RemoteException, Exception;

  /**
   * Retrieve data from bucketName/objectName (bucketName is passed to the
   * constructor)
   * 
   * @param objectName
   *          Name of the object to get from the bucket return a byte array
   *          containing the data of the object
   * @throws Exception
   *           if the command fails
   */
  public abstract byte[] get(String objectName) throws RemoteException,
	  Exception;

}